import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Spin here.
 * 
 * @author Mokhtar Ilias, Leerkracht Dhr. Potums 
 * @version 1.1
 */
public class Spin extends Actor

{
    private static final int EAST = 0;
    private static final int WEST = 1;
    private static final int NORTH = 2;
    private static final int SOUTH = 3;

    private int direction;
    
    public void act()
    {
        if(canMove()) {
            move();
        }
        else if(atWorldEdge()) {
            turnBack();
        }
        else {
            turnLeft();
        }
    }
    public boolean canMove()
    {
        World myWorld = getWorld();
        int x = getX();
        int y = getY();
        switch(direction) {
            case SOUTH :
                y++;
                break;
            case EAST :
                x++;
                break;
            case NORTH :
                y--;
                break;
            case WEST :
                x--;
                break;
        }
        // test for outside border
        if (x >= myWorld.getWidth() || y >= myWorld.getHeight()) {
            return false;
        }
        else if (x < 0 || y < 0) {
            return false;
        }
        return true;
    }
    /**
     * Sets the direction we're facing. The 'direction' parameter must
     * be in the range [0..3].
     */
    public void setDirection(int direction)
    {
        if ((direction >= 0) && (direction <= 3)) {
            this.direction = direction;
        }
        switch(direction) {
            case SOUTH :
                setRotation(90);
                break;
            case EAST :
                setRotation(0);
                break;
            case NORTH :
                setRotation(270);
                break;
            case WEST :
                setRotation(180);
                break;
            default :
                break;
        }
    }
    /**
     * Move one cell forward in the current direction.
     */
    public void move()
    {
        if (!canMove()) {
            return;
        }
        switch(direction) {
            case SOUTH :
                setLocation(getX(), getY() + 1);
                break;
            case EAST :
                setLocation(getX() + 1, getY());
                break;
            case NORTH :
                setLocation(getX(), getY() - 1);
                break;
            case WEST :
                setLocation(getX() - 1, getY());
                break;
        }
    }
    public Spin()
    {
        setDirection(EAST);
    }
    /**
     * Turns towards the left.
     */
    public void turnLeft()
    {
        switch(direction) {
            case SOUTH :
                setDirection(EAST);
                break;
            case EAST :
                setDirection(NORTH);
                break;
            case NORTH :
                setDirection(WEST);
                break;
            case WEST :
                setDirection(SOUTH);
                break;
        }
    }
     public void turnBack()
    {
        switch(direction) {
            case SOUTH :
                setDirection(NORTH);
                break;
            case EAST :
                setDirection(WEST);
                break;
            case NORTH :
                setDirection(SOUTH);
                break;
            case WEST :
                setDirection(EAST);
                break;
        }
    }
    public boolean atWorldEdge()
    {
        if(getX() < 12 || getX() > getWorld().getWidth() - 0)
            return true;
        if(getY() < 12 || getY() > getWorld().getHeight() - 0)
            return true;
        else
            return false;
    }
}

